build.sh 12 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313
  1. #!/bin/bash
  2. # (c) 2014-2016 Freifunk Hochstift <kontakt@hochstift.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  10. #
  11. # optional:
  12. # AUTOUPDATER = force Autoupdater Branch (stable/testing/experimental/off)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  15. # CLEAN = 'dirclean' to perform "make dirclean" before build or 'clean' to perform "make clean" (BRANCH==stable/testing) or 'none' (BRANCH==experimental)
  16. # KEY_DIR = specify directory for gluon-opkg-key
  17. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  18. # PRIORITY = determines the number of day a rollout phase should last at most
  19. # PUBLISH = 0 (default) or 1, publish firmware at the end
  20. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  21. # SITE_REPO_FETCH_METHOD = http, everything except "git" will use the HTTP method for fetchting site repo
  22. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  23. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  24. #
  25. ### includes
  26. . functions.sh
  27. ### static variables
  28. MY_DIR=$(dirname $0)
  29. MY_DIR=$(readlink -f "${MY_DIR}")
  30. DEFAULT_KEY_DIR="${MY_DIR}/opkg-keys"
  31. CODE_DIR="${MY_DIR}/src"
  32. GLUON_BUILD_DIR="${CODE_DIR}/build"
  33. SITE_DIR="${CODE_DIR}/site"
  34. PATCH_DIR="${SITE_DIR}/patches"
  35. OUTPUT_DIR="${MY_DIR}/output"
  36. IMAGE_DIR="${CODE_DIR}/output/images"
  37. MODULE_DIR="${CODE_DIR}/output/modules"
  38. MANIFEST_DIR="${CODE_DIR}/output/images/sysupgrade"
  39. VERSIONS_INFO_DIR="${MY_DIR}/versions"
  40. SITE_GEN_SCRIPT="${CODE_DIR}/packages/ffho/ffho/ffho-site-generate/scripts/gen-site-conf-lua"
  41. SRV_URL="firmware.in.ffho.net"
  42. SRV_USER="firmware"
  43. SRV_PATH="/srv/firmware"
  44. BUILD_INFO_FILENAME="build-info.txt"
  45. SITE_REPO_URL="git.c3pb.de/freifunk-pb/site-ffho.git"
  46. LANG=C
  47. pushd ${MY_DIR} > /dev/null
  48. ### ERROR handling
  49. [ -n "${BASE}" ] || abort "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)."
  50. [ -n "${BRANCH}" ] || abort "Please specify BRANCH environment variable."
  51. [ "${BRANCH}" == "experimental" -o "${BASE}" != "HEAD" ] || abort "HEAD is not an allowed BASE-identifier for non-experimental builds. Either use a tagged commit or the commit-SHA itself."
  52. [ -n "${VERSION}" -o "${BRANCH}" == "experimental" ] || abort "Please specify VERSION environment variable (not necessary for experimental branch)."
  53. [ "${BRANCH}" == "experimental" -o ! -r "${VERSIONS_INFO_DIR}/${VERSION}" ] || abort "There exists a version file for '${VERSION}' ... you are trying to do something really stupid, aren't you?"
  54. ### set reasonable defaults for unset environment variables
  55. [ -n "${AUTOUPDATER}" ] || AUTOUPDATER=${BRANCH}
  56. if [ -n "${BROKEN}" ]; then
  57. if [ "${BROKEN}" -eq "1" ]; then
  58. export BROKEN
  59. else
  60. unset BROKEN
  61. fi
  62. fi
  63. [ -n "${BUILD_TS}" ] || BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  64. if [ -z "${CLEAN}" ]; then
  65. if [ "${BRANCH}" == "experimental" ]; then
  66. CLEAN="none"
  67. else
  68. CLEAN="clean"
  69. fi
  70. fi
  71. if [ -n "${KEY_DIR}" ]; then
  72. KEY_DIR=$(readlink -f "${KEY_DIR}")
  73. else
  74. KEY_DIR="${DEFAULT_KEY_DIR}"
  75. fi
  76. [ -e "${KEY_DIR}" ] || mkdir -p ${KEY_DIR}
  77. [ "$?" -eq "0" ] || abort "Unable to create key directory: ${KEY_DIR}"
  78. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  79. [ -n "${PRIORITY}" ] || PRIORITY=0
  80. [ -n "${PUBLISH}" ] || PUBLISH=0
  81. [ -n "${SITE_REPO_FETCH_METHOD}" ] || SITE_REPO_FETCH_METHOD="http"
  82. [ -n "${VERBOSE}" ] || VERBOSE=0
  83. if [ "${SITE_REPO_FETCH_METHOD}" != "git" ]; then
  84. SITE_REPO_URL="https://${SITE_REPO_URL}"
  85. else
  86. SITE_REPO_URL="git@${SITE_REPO_URL}"
  87. fi
  88. MAKE_PARAM=""
  89. [ "${VERBOSE}" -eq "1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  90. ### INIT /src IF NECESSARY
  91. if [ ! -d "${CODE_DIR}" ]; then
  92. info "Code directory does not exist yet - fetching Gluon ..."
  93. git clone https://github.com/freifunk-gluon/gluon.git "${CODE_DIR}"
  94. [ "$?" -eq "0" ] || abort "Failed to fetch Gluon repository."
  95. fi
  96. ### INIT /src/site IF NECESSARY
  97. if [ ! -d "${SITE_DIR}" ]; then
  98. info "Site repository does not exist, fetching it ..."
  99. git clone "${SITE_REPO_URL}" "${SITE_DIR}"
  100. [ "$?" -eq "0" ] || abort "Failed to fetch SITE repository."
  101. fi
  102. pushd ${CODE_DIR} > /dev/null
  103. ### CHECKOUT GLUON
  104. progress "Checking out GLUON '${BASE}' ..."
  105. # check if gluon got modified and bail out if necessary
  106. [ "$(git status --porcelain)" ] && abort "Local changes to peers directory. Cowardly refusing to update gluon repository." >&2
  107. git fetch
  108. git checkout -q ${BASE}
  109. [ "$?" -eq "0" ] || abort "Failed to checkout '${BASE}' gluon base version, mimimi." >&2
  110. git show-ref --verify --quiet refs/remotes/origin/${BASE}
  111. if [ "$?" -eq "0" ]; then
  112. git pull
  113. [ "$?" -eq "0" ] || abort "Failed to get newest '${BASE}' in gluon repository, mimimi."
  114. fi
  115. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  116. ### CHECKOUT SITE REPO
  117. progress "Checking out SITE REPO ..."
  118. pushd ${SITE_DIR} > /dev/null
  119. if [ $(git remote | wc -l) -ge "1" ]; then
  120. git fetch
  121. # TODO: check if site got modified locally and bail out if necessary
  122. if [ -z "${SITE_ID}" ]; then
  123. # no specific site given - get the most current one
  124. git checkout -q ${BRANCH}
  125. git branch -r | grep ${BRANCH} > /dev/null
  126. if [ "$?" -eq "0" ]; then
  127. git rebase
  128. [ "$?" -eq "0" ] || abort "Failed to get newest '${BRANCH}' in site repository, mimimi."
  129. fi
  130. else
  131. # fetch site repo updates
  132. git fetch || true
  133. # commit given - use this one
  134. git checkout -q ${SITE_ID}
  135. [ "$?" -eq "0" ] || abort "Failed to checkout requested site commit '${SITE_ID}', mimimi."
  136. fi
  137. fi
  138. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  139. popd > /dev/null #${SITE_DIR}
  140. ### APPLY PATCHES TO GLUON
  141. progress "Applying Patches ..."
  142. git checkout -B patching "${BASE}"
  143. if [ -d "${PATCH_DIR}" -a "$(echo ${PATCH_DIR}/*.patch)" ]; then
  144. git am --whitespace=nowarn ${PATCH_DIR}/*.patch || (
  145. git am --abort
  146. git checkout patched
  147. git branch -D patching
  148. false
  149. )
  150. [ "$?" -eq "0" ] || abort "Failed to apply patches, mimimi."
  151. fi
  152. git branch -M patched
  153. ### DIRCLEAN
  154. if [ -d "${GLUON_BUILD_DIR}/" -a "${CLEAN}" == "dirclean" ]; then
  155. progress "Cleaning your build environment (make dirclean) ..."
  156. make dirclean
  157. fi
  158. ### PREPARE
  159. progress "Preparing the build environment (make update) ..."
  160. make update
  161. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  162. popd > /dev/null #${CODE_DIR}
  163. ### set reasonable defaults for ${TARGETS} and ${BRANCH} if unset
  164. if [ -z "${TARGETS}" ]; then
  165. TARGETS=$(make list-targets | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
  166. info "building all targets: '${TARGETS}'"
  167. fi
  168. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  169. VERSION=$(make default-release)
  170. info "EXPERIMENTAL FIRMWARE: using version tag '${VERSION}'"
  171. fi
  172. # we are now ready to produce the firmware images, so let's "save" our state
  173. build_info_path="${VERSIONS_INFO_DIR}/${VERSION}"
  174. progress "Saving build information to: ${build_info_path}"
  175. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  176. mkdir -p $(dirname ${build_info_path})
  177. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  178. touch $(dirname ${build_info_path})
  179. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  180. echo "VERSION=${VERSION}" >> ${build_info_path}
  181. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  182. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  183. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  184. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  185. echo "TS=${BUILD_TS}" >> ${build_info_path}
  186. ### restore gluon-opkg-key, if already exists
  187. if [ -e "${KEY_DIR}/gluon-opkg-key" -a -e "${KEY_DIR}/gluon-opkg-key.pub" ]; then
  188. info "gluon-opkg-key already exists, restoring it."
  189. mkdir -p ${GLUON_BUILD_DIR}/
  190. [ "$?" -eq "0" ] || abort "Unable to create directory: ${GLUON_BUILD_DIR}/"
  191. cp -f ${KEY_DIR}/gluon-opkg-key* ${GLUON_BUILD_DIR}/
  192. [ "$?" -eq "0" ] || abort "Unable to copy gluon-opkg-key."
  193. fi
  194. ### create site.conf
  195. if [ -x "${SITE_GEN_SCRIPT}" ]; then
  196. progress "Generating defaut site.conf"
  197. eval GLUON_SITEDIR=${SITE_DIR} ${SITE_GEN_SCRIPT}
  198. fi
  199. ### BUILD FIRMWARE
  200. progress "Building the firmware - please stand by!"
  201. pushd ${CODE_DIR} > /dev/null
  202. for target in ${TARGETS} ; do
  203. # configure build environment for our current target
  204. export GLUON_TARGET="${target}"
  205. export GLUON_RELEASE="${VERSION}"
  206. [ "${AUTOUPDATER}" != "off" ] && export GLUON_BRANCH="${AUTOUPDATER}"
  207. # prepare build environment for our current target
  208. progress "${target}: Preparing build environment."
  209. if [ "${CLEAN}" == "clean" ]; then
  210. make clean
  211. [ "$?" -eq "0" ] || abort "${target}: Unable to clean environment."
  212. fi
  213. make -j ${MAKEJOBS} prepare-target ${MAKE_PARAM}
  214. [ "$?" -eq "0" ] || abort "${target}: Unable to build environment."
  215. # need to have a toolchain for the particular target
  216. progress "${target}: Building toolchain."
  217. make -j ${MAKEJOBS} toolchain/install ${MAKE_PARAM}
  218. [ "$?" -eq "0" ] || abort "${target}: Unable to build toolchain."
  219. # now we can start building the images for the target platform
  220. progress "${target}: Building FFHO-flavoured Gluon firmware. You'd better go and fetch some c0ffee!"
  221. make -j ${MAKEJOBS} prepare ${MAKE_PARAM}
  222. [ "$?" -eq "0" ] || abort "${target}: Unable to build firmware."
  223. # finally compile the firmware binaries
  224. progress "${target}: Compiling binary firmware images."
  225. make -j ${MAKEJOBS} images ${MAKE_PARAM}
  226. [ "$?" -eq "0" ] || abort "${target}: Unable to assemble images."
  227. # compile the modules
  228. progress "${target}: Compiling modules."
  229. make -j ${MAKEJOBS} modules ${MAKE_PARAM}
  230. [ "$?" -eq "0" ] || abort "${target}: Unable to build modules."
  231. done
  232. # generate manifest
  233. progress "Generating manifest ..."
  234. GLUON_PRIORITY=${PRIORITY} GLUON_BRANCH=${BRANCH} make manifest
  235. [ "$?" -eq "0" ] || abort "Failed to generate the manifest."
  236. popd > /dev/null #${CODE_DIR}
  237. if [ "${PUBLISH}" -eq "1" ]; then
  238. # copying firmware to the server
  239. if [ -d "${IMAGE_DIR}" ]; then
  240. progress "Copying the firmware ..."
  241. rsync -rlutzc --exclude=*manifest -e ssh ${IMAGE_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}
  242. [ "$?" -eq "0" ] || abort "Failed to copy the firmware."
  243. fi
  244. # copying modules to the server
  245. if [ -d "${MODULE_DIR}" ]; then
  246. progress "Copying the modules ..."
  247. rsync -rlutzc -e ssh ${MODULE_DIR}/gluon-ffho-${VERSION}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}/modules
  248. [ "$?" -eq "0" ] || abort "Failed to copy the modules."
  249. fi
  250. # copy manifest and the build info file
  251. progress "Copying manifest and build info file ..."
  252. pushd ${OUTPUT_DIR} > /dev/null
  253. git fetch
  254. git checkout -q signing
  255. git merge --ff-only origin/master
  256. mkdir -p "${OUTPUT_DIR}/${VERSION}/sysupgrade"
  257. cp -f "${MANIFEST_DIR}/${BRANCH}.manifest" "${OUTPUT_DIR}/${VERSION}/sysupgrade/"
  258. cp -f "${build_info_path}" "${OUTPUT_DIR}/${VERSION}/${BUILD_INFO_FILENAME}"
  259. popd > /dev/null #${OUTPUT_DIR}
  260. # Update symlinks
  261. progress "Update symlink for ${BRANCH}"
  262. pushd ${OUTPUT_DIR} > /dev/null
  263. ln -fsn ${VERSION} ${BRANCH}
  264. popd > /dev/null #${OUTPUT_DIR}
  265. fi
  266. # Saving a copy of gluon-opkg-key
  267. [ -e "${KEY_DIR}/gluon-opkg-key" -a -e "${KEY_DIR}/gluon-opkg-key.pub" ] || cp ${GLUON_BUILD_DIR}/gluon-opkg-key* ${KEY_DIR}/
  268. [ "$?" -eq "0" ] || abort "Failed to save gluon-opkg-key, try to execute 'cp ${GLUON_BUILD_DIR}/gluon-opkg-key* ${KEY_DIR}/' manually"
  269. # The end. Finally.
  270. success "We're done, go and enjoy your new firmware (${VERSION})!"
  271. popd > /dev/null #${MY_DIR}